# Interface Constants

public interface Constants
Defines the names of runtime properties and named collections used in DI modules.

Since:
  3.1

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ADAPTER_DETECTORS_LIST`
  A DI container key for the List<DbAdapterDetector> that contains objects that can discover the type of current database and install the correct DbAdapter in runtime.
  `static final String`
  `CI_PROPERTY`
  Defines if database uses case-insensitive collation
  `static final String`
  `CONTEXTS_SYNC_PROPERTY`
  A boolean property defining whether cross-contexts synchronization is enabled.
  `static final String`
  `DEFAULT_TYPES_LIST`
  A DI container key for the List<ExtendedType> storing default adapter-agnostic ExtendedTypes.
  `static final String`
  `DOMAIN_LISTENERS_LIST`
  A DI container key for the List<Object> storing lifecycle events listeners.
  `static final String`
  `DOMAIN_NAME_PROPERTY`
  An optional name of the runtime DataDomain.
  `static final String`
  `EXTERNAL_TX_PROPERTY`
  A boolean property that defines whether runtime should use external transactions.
  `static final String`
  `JDBC_DRIVER_PROPERTY`
  `static final String`
  `JDBC_LOG_BATCH_ROW_THRESHOLD_PROPERTY`
  An integer property defining the maximum number of batch rows whose bindings are logged in full before the compact SQL logger truncates them to "first row .. elided count .. last row".
  `static final String`
  `JDBC_MAX_CONNECTIONS_PROPERTY`
  `static final String`
  `JDBC_MAX_QUEUE_WAIT_TIME`
  Defines a maximum time in milliseconds that a connection request could wait in the connection queue.
  `static final String`
  `JDBC_MIN_CONNECTIONS_PROPERTY`
  `static final String`
  `JDBC_PASSWORD_PROPERTY`
  `static final String`
  `JDBC_URL_PROPERTY`
  `static final String`
  `JDBC_USERNAME_PROPERTY`
  `static final String`
  `JDBC_VALIDATION_QUERY_PROPERTY`
  `static final String`
  `MAX_ID_QUALIFIER_SIZE_PROPERTY`
  A property that defines a maximum number of ID qualifiers in where clause of queries that are generated for example in `IncrementalFaultList` or in DISJOINT_BY_ID prefetch processing.
  `static final String`
  `OBJECT_RETAIN_STRATEGY_PROPERTY`
  A String property that defines how ObjectContexts should retain cached committed objects.
  `static final String`
  `PROJECT_LOCATIONS_LIST`
  A DI container key for the List<String> storing locations of the one of more project configuration files.
  `static final String`
  `PROPERTIES_MAP`
  A DI container key for the Map<String, String> storing properties used by built-in Cayenne service.
  `static final String`
  `QUERY_CACHE_SIZE_PROPERTY`
  An integer property defining the maximum number of entries in the query cache.
  `static final String`
  `QUERY_EXECUTION_TIME_LOGGING_THRESHOLD_PROPERTY`
  Deprecated.
  since 5.0 this property is ignored.
  `static final String`
  `RESOURCE_LOCATOR`
  A DI container key for binding `ResourceLocator`
  `static final String`
  `SERVER_ADAPTER_DETECTORS_LIST`
  Deprecated, for removal: This API element is subject to removal in a future version.
  use `ADAPTER_DETECTORS_LIST`
  `static final String`
  `SERVER_CONTEXTS_SYNC_PROPERTY`
  Deprecated, for removal: This API element is subject to removal in a future version.
  use `CONTEXTS_SYNC_PROPERTY`
  `static final String`
  `SERVER_DEFAULT_TYPES_LIST`
  Deprecated, for removal: This API element is subject to removal in a future version.
  use `DEFAULT_TYPES_LIST`
  `static final String`
  `SERVER_DOMAIN_LISTENERS_LIST`
  Deprecated, for removal: This API element is subject to removal in a future version.
  use `DOMAIN_LISTENERS_LIST`
  `static final String`
  `SERVER_DOMAIN_NAME_PROPERTY`
  Deprecated, for removal: This API element is subject to removal in a future version.
  use `DOMAIN_NAME_PROPERTY`
  `static final String`
  `SERVER_EXTERNAL_TX_PROPERTY`
  Deprecated, for removal: This API element is subject to removal in a future version.
  use `EXTERNAL_TX_PROPERTY`
  `static final String`
  `SERVER_MAX_ID_QUALIFIER_SIZE_PROPERTY`
  Deprecated, for removal: This API element is subject to removal in a future version.
  use `MAX_ID_QUALIFIER_SIZE_PROPERTY`
  `static final String`
  `SERVER_OBJECT_RETAIN_STRATEGY_PROPERTY`
  Deprecated, for removal: This API element is subject to removal in a future version.
  use `CONTEXTS_SYNC_PROPERTY`
  `static final String`
  `SERVER_PROJECT_LOCATIONS_LIST`
  Deprecated, for removal: This API element is subject to removal in a future version.
  use `PROJECT_LOCATIONS_LIST`
  `static final String`
  `SERVER_RESOURCE_LOCATOR`
  Deprecated, for removal: This API element is subject to removal in a future version.
  use `RESOURCE_LOCATOR`
  `static final String`
  `SERVER_TYPE_FACTORIES_LIST`
  Deprecated, for removal: This API element is subject to removal in a future version.
  use `TYPE_FACTORIES_LIST`
  `static final String`
  `SERVER_USER_TYPES_LIST`
  Deprecated, for removal: This API element is subject to removal in a future version.
  use `USER_TYPES_LIST`
  `static final String`
  `SNAPSHOT_CACHE_SIZE_PROPERTY`
  Snapshot cache max size
  `static final String`
  `TYPE_FACTORIES_LIST`
  A DI container key for the List<ExtendedTypeFactory> storing default and user-provided ExtendedTypeFactories.
  `static final String`
  `USER_TYPES_LIST`
  A DI container key for the List<ExtendedType> storing a user-provided ExtendedTypes.

- ## Field Details

  - ### PROPERTIES_MAP

    static final String PROPERTIES_MAP
    A DI container key for the Map<String, String> storing properties used by built-in Cayenne service.
    See Also:
      - `CoreModuleExtender.setProperty(String, Object)`
      - Constant Field Values

  - ### ADAPTER_DETECTORS_LIST

    static final String ADAPTER_DETECTORS_LIST
    A DI container key for the List<DbAdapterDetector> that contains objects that can discover the type of current database and install the correct DbAdapter in runtime.
    See Also:
      - Constant Field Values

  - ### SERVER_ADAPTER_DETECTORS_LIST

    @Deprecated(since="5.0", forRemoval=true) static final String SERVER_ADAPTER_DETECTORS_LIST
    Deprecated, for removal: This API element is subject to removal in a future version.
    use `ADAPTER_DETECTORS_LIST`
    See Also:
      - Constant Field Values

  - ### DOMAIN_LISTENERS_LIST

    static final String DOMAIN_LISTENERS_LIST
    A DI container key for the List<Object> storing lifecycle events listeners.
    See Also:
      - `CoreModuleExtender.addListener(Object)`
      - Constant Field Values

  - ### SERVER_DOMAIN_LISTENERS_LIST

    @Deprecated(since="5.0", forRemoval=true) static final String SERVER_DOMAIN_LISTENERS_LIST
    Deprecated, for removal: This API element is subject to removal in a future version.
    use `DOMAIN_LISTENERS_LIST`
    See Also:
      - Constant Field Values

  - ### PROJECT_LOCATIONS_LIST

    static final String PROJECT_LOCATIONS_LIST
    A DI container key for the List<String> storing locations of the one of more project configuration files.
    See Also:
      - Constant Field Values

  - ### SERVER_PROJECT_LOCATIONS_LIST

    @Deprecated(since="5.0", forRemoval=true) static final String SERVER_PROJECT_LOCATIONS_LIST
    Deprecated, for removal: This API element is subject to removal in a future version.
    use `PROJECT_LOCATIONS_LIST`
    See Also:
      - Constant Field Values

  - ### DEFAULT_TYPES_LIST

    static final String DEFAULT_TYPES_LIST
    A DI container key for the List<ExtendedType> storing default adapter-agnostic ExtendedTypes.
    See Also:
      - `CoreModuleExtender.addDefaultExtendedType(ExtendedType)`
      - Constant Field Values

  - ### SERVER_DEFAULT_TYPES_LIST

    @Deprecated(since="5.0", forRemoval=true) static final String SERVER_DEFAULT_TYPES_LIST
    Deprecated, for removal: This API element is subject to removal in a future version.
    use `DEFAULT_TYPES_LIST`
    See Also:
      - Constant Field Values

  - ### USER_TYPES_LIST

    static final String USER_TYPES_LIST
    A DI container key for the List<ExtendedType> storing a user-provided ExtendedTypes.
    See Also:
      - `CoreModuleExtender.addUserExtendedType(ExtendedType)`
      - Constant Field Values

  - ### SERVER_USER_TYPES_LIST

    @Deprecated(since="5.0", forRemoval=true) static final String SERVER_USER_TYPES_LIST
    Deprecated, for removal: This API element is subject to removal in a future version.
    use `USER_TYPES_LIST`
    See Also:
      - Constant Field Values

  - ### TYPE_FACTORIES_LIST

    static final String TYPE_FACTORIES_LIST
    A DI container key for the List<ExtendedTypeFactory> storing default and user-provided ExtendedTypeFactories.
    See Also:
      - `CoreModuleExtender.addExtendedTypeFactory(Class)`
      - Constant Field Values

  - ### SERVER_TYPE_FACTORIES_LIST

    @Deprecated(since="5.0", forRemoval=true) static final String SERVER_TYPE_FACTORIES_LIST
    Deprecated, for removal: This API element is subject to removal in a future version.
    use `TYPE_FACTORIES_LIST`
    See Also:
      - Constant Field Values

  - ### RESOURCE_LOCATOR

    static final String RESOURCE_LOCATOR
    A DI container key for binding `ResourceLocator`
    See Also:
      - Constant Field Values

  - ### SERVER_RESOURCE_LOCATOR

    @Deprecated(since="5.0", forRemoval=true) static final String SERVER_RESOURCE_LOCATOR
    Deprecated, for removal: This API element is subject to removal in a future version.
    use `RESOURCE_LOCATOR`
    See Also:
      - Constant Field Values

  - ### JDBC_DRIVER_PROPERTY

    static final String JDBC_DRIVER_PROPERTY
    See Also:
      - Constant Field Values

  - ### JDBC_URL_PROPERTY

    static final String JDBC_URL_PROPERTY
    See Also:
      - Constant Field Values

  - ### JDBC_USERNAME_PROPERTY

    static final String JDBC_USERNAME_PROPERTY
    See Also:
      - Constant Field Values

  - ### JDBC_PASSWORD_PROPERTY

    static final String JDBC_PASSWORD_PROPERTY
    See Also:
      - Constant Field Values

  - ### JDBC_MIN_CONNECTIONS_PROPERTY

    static final String JDBC_MIN_CONNECTIONS_PROPERTY
    See Also:
      - Constant Field Values

  - ### JDBC_MAX_CONNECTIONS_PROPERTY

    static final String JDBC_MAX_CONNECTIONS_PROPERTY
    See Also:
      - Constant Field Values

  - ### JDBC_MAX_QUEUE_WAIT_TIME

    static final String JDBC_MAX_QUEUE_WAIT_TIME
    Defines a maximum time in milliseconds that a connection request could wait in the connection queue. After this period expires, an exception will be thrown in the calling method. A value of zero will make the thread wait until a connection is available with no time out. Defaults to 20 seconds.
    Since:
      4.0
    See Also:
      - Constant Field Values

  - ### JDBC_VALIDATION_QUERY_PROPERTY

    static final String JDBC_VALIDATION_QUERY_PROPERTY
    Since:
      4.0
    See Also:
      - Constant Field Values

  - ### QUERY_CACHE_SIZE_PROPERTY

    static final String QUERY_CACHE_SIZE_PROPERTY
    An integer property defining the maximum number of entries in the query cache. Note that not all QueryCache providers may respect this property. MapQueryCache uses it, but the rest would use alternative configuration methods.
    See Also:
      - Constant Field Values

  - ### DOMAIN_NAME_PROPERTY

    static final String DOMAIN_NAME_PROPERTY
    An optional name of the runtime DataDomain. If not specified (which is normally the case), the name is inferred from the configuration name.
    Since:
      4.0
    See Also:
      - Constant Field Values

  - ### SERVER_DOMAIN_NAME_PROPERTY

    @Deprecated(since="5.0", forRemoval=true) static final String SERVER_DOMAIN_NAME_PROPERTY
    Deprecated, for removal: This API element is subject to removal in a future version.
    use `DOMAIN_NAME_PROPERTY`
    See Also:
      - Constant Field Values

  - ### CONTEXTS_SYNC_PROPERTY

    static final String CONTEXTS_SYNC_PROPERTY
    A boolean property defining whether cross-contexts synchronization is enabled. Possible values are "true" or "false".
    See Also:
      - Constant Field Values

  - ### SERVER_CONTEXTS_SYNC_PROPERTY

    @Deprecated(since="5.0", forRemoval=true) static final String SERVER_CONTEXTS_SYNC_PROPERTY
    Deprecated, for removal: This API element is subject to removal in a future version.
    use `CONTEXTS_SYNC_PROPERTY`
    See Also:
      - Constant Field Values

  - ### OBJECT_RETAIN_STRATEGY_PROPERTY

    static final String OBJECT_RETAIN_STRATEGY_PROPERTY
    A String property that defines how ObjectContexts should retain cached committed objects. Possible values are "weak", "soft", "hard".
    See Also:
      - Constant Field Values

  - ### SERVER_OBJECT_RETAIN_STRATEGY_PROPERTY

    @Deprecated(since="5.0", forRemoval=true) static final String SERVER_OBJECT_RETAIN_STRATEGY_PROPERTY
    Deprecated, for removal: This API element is subject to removal in a future version.
    use `CONTEXTS_SYNC_PROPERTY`
    See Also:
      - Constant Field Values

  - ### EXTERNAL_TX_PROPERTY

    static final String EXTERNAL_TX_PROPERTY
    A boolean property that defines whether runtime should use external transactions. Possible values are "true" or "false".
    See Also:
      - Constant Field Values

  - ### SERVER_EXTERNAL_TX_PROPERTY

    @Deprecated(since="5.0", forRemoval=true) static final String SERVER_EXTERNAL_TX_PROPERTY
    Deprecated, for removal: This API element is subject to removal in a future version.
    use `EXTERNAL_TX_PROPERTY`
    See Also:
      - Constant Field Values

  - ### MAX_ID_QUALIFIER_SIZE_PROPERTY

    static final String MAX_ID_QUALIFIER_SIZE_PROPERTY
    A property that defines a maximum number of ID qualifiers in where clause of queries that are generated for example in `IncrementalFaultList` or in DISJOINT_BY_ID prefetch processing. This is needed to avoid where clause size limitations and memory usage efficiency.
    See Also:
      - Constant Field Values

  - ### SERVER_MAX_ID_QUALIFIER_SIZE_PROPERTY

    @Deprecated(since="5.0", forRemoval=true) static final String SERVER_MAX_ID_QUALIFIER_SIZE_PROPERTY
    Deprecated, for removal: This API element is subject to removal in a future version.
    use `MAX_ID_QUALIFIER_SIZE_PROPERTY`
    See Also:
      - Constant Field Values

  - ### CI_PROPERTY

    static final String CI_PROPERTY
    Defines if database uses case-insensitive collation
    See Also:
      - Constant Field Values

  - ### QUERY_EXECUTION_TIME_LOGGING_THRESHOLD_PROPERTY

    @Deprecated(since="5.0") static final String QUERY_EXECUTION_TIME_LOGGING_THRESHOLD_PROPERTY
    Deprecated.
    since 5.0 this property is ignored. The slow-query threshold warning was removed as part of the compact SQL logger redesign (CAY-2912).
    A integer property that used to enable logging for just long running queries (rather than all queries).
    Since:
      4.0
    See Also:
      - Constant Field Values

  - ### JDBC_LOG_BATCH_ROW_THRESHOLD_PROPERTY

    static final String JDBC_LOG_BATCH_ROW_THRESHOLD_PROPERTY
    An integer property defining the maximum number of batch rows whose bindings are logged in full before the compact SQL logger truncates them to "first row .. elided count .. last row". Default is 20.
    Since:
      5.0
    See Also:
      - Constant Field Values

  - ### SNAPSHOT_CACHE_SIZE_PROPERTY

    static final String SNAPSHOT_CACHE_SIZE_PROPERTY
    Snapshot cache max size
    Since:
      4.0
    See Also:
      - `CoreModuleExtender.snapshotCacheSize(int)`
      - Constant Field Values